'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = function (_ref4) {
  var _extends2;

  var name = _ref4.name,
      relationshipDefinitions = _ref4.relationshipDefinitions,
      _ref4$defaultStateCon = _ref4.defaultStateConfig,
      defaultStateConfig = _ref4$defaultStateCon === undefined ? {} : _ref4$defaultStateCon,
      _ref4$otherActions = _ref4.otherActions,
      otherActions = _ref4$otherActions === undefined ? {} : _ref4$otherActions;

  var mapOfRelationshipDefaultValues = getMapOfRelationshipDefaultValues(relationshipDefinitions);
  var mapOfRelationshipTypes = getMapOfRelationshipTypes(relationshipDefinitions);
  var mapOfRelationships = getMapOfRelationships(relationshipDefinitions);
  var removeActions = Object.keys(mapOfRelationships).reduce(function (finalResult, relatedEntityName) {
    finalResult[_resourceActionTypes2.default.remove(relatedEntityName)] = _handlers2.default.remove(mapOfRelationshipTypes, mapOfRelationships, relatedEntityName);
    return finalResult;
  }, {});
  return (0, _reduxActions.handleActions)(_extends((_extends2 = {}, _defineProperty(_extends2, _resourceActionTypes2.default.link(name), _handlers2.default.link(mapOfRelationshipTypes)), _defineProperty(_extends2, _resourceActionTypes2.default.unlink(name), _handlers2.default.unlink(mapOfRelationshipTypes)), _defineProperty(_extends2, _resourceActionTypes2.default.createRelationship(name), _handlers2.default.createRelationship(mapOfRelationshipTypes)), _defineProperty(_extends2, _resourceActionTypes2.default.indexRelationship(name), _handlers2.default.indexRelationship(mapOfRelationshipTypes)), _extends2), removeActions, otherActions), (0, _generateDefaultState2.default)(_extends({}, mapOfRelationshipDefaultValues, defaultStateConfig)));
};

var _immutable = require('immutable');

var _reduxActions = require('redux-actions');

var _resourceActionTypes = require('resource-action-types');

var _resourceActionTypes2 = _interopRequireDefault(_resourceActionTypes);

var _handlers = require('./handlers');

var _handlers2 = _interopRequireDefault(_handlers);

var _generateDefaultState = require('./generateDefaultState');

var _generateDefaultState2 = _interopRequireDefault(_generateDefaultState);

var _relationshipTypes = require('./relationshipTypes');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function getMapOfRelationshipDefaultValues(relationshipDefinitions) {
  return relationshipDefinitions.reduce(function (finalResult, _ref) {
    var name = _ref.name;

    finalResult[name] = new _immutable.Map();
    return finalResult;
  }, {});
}

function getMapOfRelationshipTypes(relationshipDefinitions) {
  return relationshipDefinitions.reduce(function (finalResult, _ref2) {
    var name = _ref2.name,
        type = _ref2.type;

    finalResult[name] = type;
    return finalResult;
  }, {});
}

function getMapOfRelationships(relationshipDefinitions) {
  return relationshipDefinitions.reduce(function (finalResult, _ref3) {
    var name = _ref3.name,
        relatedEntityName = _ref3.relatedEntityName;

    if (!finalResult[relatedEntityName]) {
      finalResult[relatedEntityName] = [];
    }
    finalResult[relatedEntityName].push(name);
    return finalResult;
  }, {});
}